#include <allegro.h>

/* does pixel-perfect collision detection */
int detect_collision(int x1, int y1, BITMAP * sprite1, int x2, int y2, BITMAP * sprite2)
{
    int has_collided;
    int bx1, by1, bx2, by2, bx3, by3; // Our rectangular intersection points
    int x, y, lenx, leny;  // Used for the detection loop

    has_collided = FALSE;  // Let's start with no preconceptions

    // First, do bounding-box detection
    if(((x1 + sprite1->w) >= x2) && (x1 < (x2 + sprite2->w)) && ((y1 + sprite1->h) >= y2) && (y1 < (y2 + sprite2->h)))
    {
        // Compute the intersection point
        bx1 = x1 - x2;
        if(bx1 < 0)
        {
            bx1 = 0;
        }
        by1 = y1 - y2;
        if(by1 < 0)
        {
            by1 = 0;
        }
        if(x1 < x2)
        {
            bx2 = x2 - x1;
        }
        else
        {
            bx2 = 0;
        }
        if(y1 < y2)
        {
            by2 = y2 - y1;
        }
        else
        {
            by2 = 0;
        }
        if(x1 > x2 + sprite2->w - sprite1->w)
        {
            bx3 = x2 + sprite2->w - x1;
        }
        else
        {
            bx3 = sprite1->w;
        }

        if(y1 > y2 + sprite2->h - sprite1->h)
        {
            by3 = y2 + sprite2->h - y1;
        }
        else
        {
            by3 = sprite1->h;
        }

        lenx = abs (bx2 - bx3);
        leny = abs (by2 - by3);

        // Now, do pixel-perfect detection on the intersection rectangle
        for(y = 0; y < leny; y++)
        {
            for(x = 0; x < lenx; x++)
            {
                if(sprite1->line[by2 + y][bx2 + x] != 0)
                {
                    if(sprite2->line[by1 + y][bx1 + x] != 0)
                    {
                        has_collided = TRUE;
                    }
                }
            }
        }
    }
    return has_collided;
}
