#include "includes.h"

void generate_pulsars(void)
{
    if(chance(pulsar_prob[level], PROB_TOTAL) && astro_state != ASTRO_STATE_BOSS && astro_state != ASTRO_STATE_LEVEL_COMPLETE && astro_state != ASTRO_STATE_GAME_OVER && astro_state != ASTRO_STATE_GAME_COMPLETE)
    {
        for(int i = 0; i < MAX_PULSARS; i++)
        {
            if(!pulsar[i].active())
            {
                pulsar[i].set_position(fix(ncd_random() % 304), fix(-16));
                t3ss_play_sound(missile_sound, t3ss_place_sound(pulsar[i].get_ox(), 318), I_NULL);
                pulsar[i].activate();
                break;
            }
        }
    }
}

void move_pulsars(void)
{
    for(int i = 0; i < MAX_PULSARS; i++)
    {
        pulsar[i].follow_center(&turret, drop_speed_chart[level] + 0.25);
        pulsar[i].accelerate(0, 1);
        pulsar[i].update_position();
        if(pulsar[i].collide_rect(fix(0), fix(172), fix(320), fix(40)))
        {
            pulsar[i].deactivate();
            generate_explosion(&pulsar[i]);
        }

        /* see if pulsar is hitting asteroids */
        for(int j = 0; j < MAX_BIG_ASTEROIDS; j++)
        {
            if(pulsar[i].collide(&big_asteroid[j]))
            {
                big_asteroid[j].deactivate();
                pulsar[i].deactivate();
                if(chance(asteroid_split_prob[level], PROB_TOTAL) && can_split() && big_asteroid[j].get_oy() < 86)
                {
                    split_big_asteroid(j);
                }
                generate_explosion(&pulsar[i]);
                generate_explosion(&big_asteroid[j]);
                break;
            }
        }

        /* see if pulsar is hitting asteroids */
        for(int j = 0; j < MAX_SMALL_ASTEROIDS; j++)
        {
            if(pulsar[i].collide(&small_asteroid[j]))
            {
                small_asteroid[j].deactivate();
                pulsar[i].deactivate();
                generate_explosion(&pulsar[i]);
                generate_explosion(&small_asteroid[j]);
                break;
            }
        }

        /* see if pulsar is hitting spinners */
        for(int j = 0; j < MAX_SMALL_SPINNERS; j++)
        {
            if(pulsar[i].collide(&small_spinner[j]))
            {
                small_spinner[j].deactivate();
                pulsar[i].deactivate();
                generate_explosion(&pulsar[i]);
                generate_explosion(&small_spinner[j]);
                break;
            }
        }

        /* see if pulsar is hitting spinners */
        for(int j = 0; j < MAX_BIG_SPINNERS; j++)
        {
            if(pulsar[i].collide(&big_spinner[j]))
            {
                big_spinner[j].deactivate();
                pulsar[i].deactivate();
                generate_explosion(&pulsar[i]);
                generate_explosion(&big_spinner[j]);
                break;
            }
        }

        /* see if pulsar is hitting ufos */
        for(int j = 0; j < MAX_UFOS; j++)
        {
            if(pulsar[i].collide(&ufo[j]))
            {
                ufo[j].deactivate();
                pulsar[i].deactivate();
                generate_explosion(&pulsar[i]);
                generate_explosion(&ufo[j]);
                break;
            }
        }
    }
}

void do_pulsars(void)
{
    generate_pulsars();
    move_pulsars();
}
